//----------------------------------------------------------------------------
//  Project C32T12Control
//  CGC Instruments
//  Copyright  2003. Alle Rechte vorbehalten.
//
//  SUBSYSTEM:    C32T12Control Application
//  FILE:         C32T12ControlApp.cpp
//  AUTHOR:       Ivo Cermak
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TC32T12ControlApp (TApplication).
//
//----------------------------------------------------------------------------

#include <owl/pch.h>

#include <stdio.h>

#include "C32T12ControlApp.h"
#include "C32T12ControlDlgClient.h"                        // Definition of client class.


//{{TC32T12ControlApp Implementation}}


//
// Build a response table for all messages/commands handled
// by the application.
//
DEFINE_RESPONSE_TABLE1(TC32T12ControlApp, TApplication)
//{{TC32T12ControlAppRSP_TBL_BEGIN}}
//{{TC32T12ControlAppRSP_TBL_END}}
END_RESPONSE_TABLE;


//--------------------------------------------------------
// TC32T12ControlApp
//
TC32T12ControlApp::TC32T12ControlApp() : TApplication("C32T12Control") {
	// INSERT>> Your constructor code here.
	}


TC32T12ControlApp::~TC32T12ControlApp() {
	// INSERT>> Your destructor code here.
	}


//--------------------------------------------------------
// TC32T12ControlApp
// ~~~~~
// Application intialization.
//
void TC32T12ControlApp::InitMainWindow() {
	if (nCmdShow != SW_HIDE) nCmdShow = (nCmdShow != SW_SHOWMINNOACTIVE) ? SW_SHOWNORMAL : nCmdShow;

	TSDIDecFrame* frame = new TSDIDecFrame(0, GetName(), 0, false);
	frame->SetFlag(wfShrinkToClient);

	// Override the default window style for the main window.
	//
		frame->Attr.Style |= WS_BORDER | WS_CAPTION | WS_MINIMIZEBOX | WS_SYSMENU | WS_VISIBLE;
		frame->Attr.Style &= ~(WS_CHILD | WS_CLIPCHILDREN | WS_MAXIMIZEBOX | WS_THICKFRAME);

	// Assign ICON w/ this application.
	//
	frame->SetIcon(this, IDI_SDIAPPLICATION);
	frame->SetIconSm(this, IDI_SDIAPPLICATION);

	SetMainWindow(frame);
	}



//{{TSDIDecFrame Implementation}}


TSDIDecFrame::TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection, TModule* module) :
	TDecoratedFrame(parent, title, !clientWnd ? new TC32T12ControlDlgClient(0) : clientWnd, trackMenuSelection, module) {
	// INSERT>> Your constructor code here.
	}


TSDIDecFrame::~TSDIDecFrame() {
	// INSERT>> Your destructor code here.
	}


//--------------------------------------------------------
// TC32T12ControlApp
// ~~~~~~~~~~~
// Menu Help About C32T12Control command
//
void TC32T12ControlApp::CmHelpAbout()
	{ }


int OwlMain(int , char* [])
 { TC32T12ControlApp App; return App.Run(); }
