//----------------------------------------------------------------------------
//  Project C32T12Control
//  CGC Instruments
//  Copyright  2003. Alle Rechte vorbehalten.
//
//  SUBSYSTEM:    C32T12Control Application
//  FILE:         C32T12ControlDlgClient.h
//  AUTHOR:       Ivo Cermak
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TC32T12ControlDlgClient (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(C32T12ControlDlgClient_h)
#define C32T12ControlDlgClient_h

#include <owl/updown.h>
#include <owl/checkbox.h>

#include "C32T12ControlApp.rh"


class TC32T12ControlDlgClient : public TDialog {
	public:
		TC32T12ControlDlgClient (TWindow * parent, TResId resId = IDD_CLIENT, TModule * module = 0);
		~TC32T12ControlDlgClient();

		bool CheckStatus (int Status);
		bool CheckPresence();

		unsigned long Counts;
		unsigned GateTime;

		//void IfcUpdate();
		void CntUpdate();
		void TmrUpdate();

		virtual void SetupWindow();
		virtual bool CanClose();
		virtual bool IdleAction (long idleCount);

	protected:
		bool isOpen, isPresent;
		bool Running;
		double ClockFrequency;

		void IfcInit();
		void IfcOpen();
		void IfcClose();

		void UpdateData();
		void UpdateStatus();
		void FlipStatusBit (BYTE Mask);

		int GetButtonFlag (int Status, int BitMask) { return !isPresent ? BF_GRAYED : (Status & BitMask) ? BF_CHECKED : BF_UNCHECKED; }

		virtual void CmOk();
		virtual void CmCancel() {}

		void EvTimer (uint TimerId);
		void BNMeasSingleClicked();
		void BNMeasRunClicked();
		void BNInputNegClicked();
		void BNGateEnClicked();
		void BNGateCtrlClicked();
		void BNResetClicked();
		void BNTestClicked();
		void BNMeasureClicked();

		WORD ConvertDelay (double & Delay, int Delta);
		void SetDelay (WORD CtrlValue, bool TrailingSlope, int Channel);

		void ProcessDelay (int Channel, int Delta = 0, bool SwTrigger = false);

		void ENClockChange();
		void UpdateCh1();
		void UpdateCh2();
		bool UDNDelayCh1Deltapos (TNmUpDown& UpDn);
		bool UDNDelayCh2Deltapos (TNmUpDown& UpDn);
		void BNSwTriggerCh1Clicked();
		void BNSwTriggerCh2Clicked();

DECLARE_RESPONSE_TABLE(TC32T12ControlDlgClient);

};


#endif // C32T12ControlDlgClient_h
