//----------------------------------------------------------------------------
//  Project C32T12Control
//  CGC Instruments
//  Copyright  2003. Alle Rechte vorbehalten.
//
//  SUBSYSTEM:    C32T12Control.apx Application
//  FILE:         MeasureBase.cpp
//  AUTHOR:       Ivo Cermak
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TMeasureBase (TDialog).
//
//----------------------------------------------------------------------------
#include <owl/pch.h>

#include "MeasureBase.h"

#include "C32T12.h"


//{{TMeasureBase Implementation}}


TMeasureBase::TMeasureBase (TC32T12ControlDlgClient * parent, TResId resId, TModule * module) : TDialog (parent, resId, module)
	{ IfcParent = parent; }

TMeasureBase::~TMeasureBase()
 { Destroy(); }


void TMeasureBase::GetStatus (BYTE & Status) {
	const Result = CNT32_GetStatus (Status);
	if (Result) IfcParent->CheckStatus (Result);
	}

void TMeasureBase::SetStatus (BYTE Status) {
	const Result = CNT32_SetStatus (Status);
	if (Result) IfcParent->CheckStatus (Result);
	}

void TMeasureBase::ChangeStatus (BYTE * StatusBytes, unsigned Count) {
	const Result = CNT32_ChangeStatus (StatusBytes, Count);
	if (Result) IfcParent->CheckStatus (Result);
	}

void TMeasureBase::Reset() {
	const Result = CNT32_Reset();
	if (Result) IfcParent->CheckStatus (Result);
	}

