//----------------------------------------------------------------------------
//  Project C32T12Control
//  CGC Instruments
//  Copyright  2003. Alle Rechte vorbehalten.
//
//  SUBSYSTEM:    C32T12Control.apx Application
//  FILE:         TestDialog.cpp
//  AUTHOR:       Ivo Cermak
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TTestDialog (TDialog).
//
//----------------------------------------------------------------------------
#include <owl/pch.h>
#include <stdio.h>

#include "TestDialog.h"

#include "C32T12.h"


//{{TTestDialog Implementation}}


TTestDialog::TTestDialog (TC32T12ControlDlgClient * parent, TResId resId, TModule * module) : TMeasureBase (parent, resId, module)
	{ }


bool TTestDialog::IdleAction (long) {
	enum { MaxStep = 0x400 }; static BYTE Buffer [MaxStep*2];
	unsigned Step = rand() % MaxStep + 1; SetDlgItemInt (IDC_COUNTS, Step, false);
	unsigned long NewCounts = IfcParent->Counts + Step; const BYTE OffValue = OrgStatus, OnValue = (OrgStatus ^ BYTE (CNT32_InputNeg));
	BYTE * Ptr = Buffer; for (int n = 0; n < Step; n++) { *Ptr++ = OnValue; *Ptr++ = OffValue; }
	ChangeStatus (Buffer, Step*2);
	IfcParent->CntUpdate();
	if (IfcParent->Counts != NewCounts) {
		char TitleString    [100]; GetModule()->LoadString (IDS_TEST_ERROR_TITLE, TitleString,    sizeof (TitleString));
		char CounterString  [100]; GetModule()->LoadString (IDS_TEST_ERROR_CNT,   CounterString,  sizeof (CounterString));
		char ExpectedString [100]; GetModule()->LoadString (IDS_TEST_ERROR_EXP,   ExpectedString, sizeof (ExpectedString));
		char Text [200]; sprintf (Text, "%s: %lu, %s: %lu", CounterString, IfcParent->Counts, ExpectedString, NewCounts);
		if (MessageBox (Text, TitleString, MB_OKCANCEL) == IDCANCEL) CmCancel();
		}
	return true;
	}


void TTestDialog::SetupWindow() {
	char Message [100]; GetModule()->LoadString (IDS_TEST, Message, sizeof (Message)); MessageBox (Message);
	TDialog::SetupWindow();
	if (!InitMeasurement()) { Reset(); InitMeasurement(); }
	IfcParent->CntUpdate();
	}


bool TTestDialog::InitMeasurement() {
	BYTE Status; GetStatus (Status); Status &= CNT32_MeasSngl; BYTE Buffer [3];
	Status |= CNT32_InputNeg; Buffer [0] = Status;
	Status |= CNT32_MeasRun;  Buffer [1] = Status;
	Status |= CNT32_GateCtrl; Buffer [2] = Status;
	ChangeStatus (Buffer, 3); GetStatus (Status); OrgStatus = Status;
	return (Status & CNT32_MeasAct) != 0;
	}

